# Working With GitLab CI/CD Artifacts

In GitLab CI/CD, artifacts play a crucial role in optimizing pipelines by allowing the sharing of data between jobs, and storing build outputs for further analysis or deployment. This README provides an overview of GitLab artifacts and demonstrates how they can be utilized to enhance pipeline efficiency.

[TOC]

## What are GitLab Artifacts?
GitLab artifacts are the files generated during the execution of CI/CD pipelines. These files can include build outputs, test results, logs, and any other data produced by pipeline jobs. Artifacts are stored temporarily and can be accessed by subsequent pipeline stages or downloaded manually for inspection.

## How to Use GitLab Artifacts in Pipeline Optimization
### Defining Artifacts in GitLab CI/CD Configuration
To start using artifacts in your GitLab CI/CD pipelines, you need to define which files or directories should be saved as artifacts. This is done using the artifacts keyword within your job configuration. For example:

```yaml
build:
  image: gitlab.home.arpa:5050/developer/workshop/project-image:latest
  stage: build
  script:
    - cmake -S . -B build
    - cmake --build build
  artifacts:
    paths:
      - build/
```

In this example, the build/ directory is specified as an artifact, meaning all files and subdirectories within it will be saved after the build job completes.

### Sharing Artifacts Between Jobs
One of the primary benefits of artifacts is the ability to share data between different jobs within the same pipeline. This can significantly speed up pipeline execution by eliminating redundant build steps or computations. To share artifacts between jobs, you can use the dependencies keyword to specify which previous jobs' artifacts should be used. For example:

```yaml
test:
  image: gitlab.home.arpa:5050/developer/workshop/project-image:latest
  stage: test
  script:
    - ./build/main > output.txt
    - cat output.txt
    - |
      if grep -q "Hello, GitLab CI/CD!" output.txt; then
        echo "Test Passed"
      else
        echo "Test Failed"
        exit 1
      fi
  dependencies:
    - build
```

In this example, the test job depends on the build job, meaning it will have access to the artifacts generated by the build job, such as the compiled executable.

### Setting Artifact Expiration
GitLab allows you to specify expiration policies for artifacts to manage storage space efficiently. By default, artifacts are retained indefinitely, but you can configure them to expire after a certain period or upon a specific event, such as successful deployment. This helps prevent storage bloat and ensures that only relevant artifacts are retained. To set artifact expiration, you can use the expire_in keyword within your job configuration. For example:

```yaml
build:
  image: gitlab.home.arpa:5050/developer/workshop/project-image:latest
  stage: build
  script:
    - cmake -S . -B build
    - cmake --build build
  artifacts:
    paths:
      - build/
    expire_in: 1 week
```

In this example, the artifacts generated by the build job will expire and be automatically deleted after one week.

### Storing Build Outputs for Analysis or Deployment
Artifacts can also be used to store build outputs for further analysis, deployment, or archival purposes. For example, you can save test results, code coverage reports, or deployment packages as artifacts and access them later. Ensure to define the appropriate paths for storing relevant artifacts in your job configurations.

## Conclusion
GitLab artifacts are a powerful feature that can be leveraged to optimize CI/CD pipelines by sharing data between jobs and storing build outputs. By effectively utilizing artifacts in your pipeline configurations, you can improve overall pipeline performance and efficiency while managing storage space effectively through expiration policies.

[Overview](../../README.md) | [Back](./02_adding_additional_stages.md) | [Next](./04_yaml_variables_anchors_references.md)
